using System.IO;
using System.Windows.Forms;
using System.Collections.Generic;

namespace Pak
{
    class InjectManager
    {
        static readonly string pakpath = @"c:\program files\funcom\dreamfall\bin\res\";

        List<NameTable> nameTables = null;
        static InjectManager _instance = null;

        public static InjectManager instance
        {
            get
            {
                if (_instance == null)
                    _instance = new InjectManager();
                return _instance;
            }
        }

        private InjectManager()
        {
            nameTables = new List<NameTable>();
            foreach (string file in Directory.GetFiles(pakpath))
                if (NameTable.isValid(file))
                {
                    nameTables.Add(new NameTable(file));
                }
        }

        public void inject(string file)
        {
            if (!file.StartsWith(pakpath, System.StringComparison.InvariantCultureIgnoreCase))
                MessageBox.Show("File is not located in local pak repository !");
            else
            {
                string cfile = file.Substring(pakpath.Length);
                FileEntry entry = null;
                foreach (NameTable table in nameTables)
                {
                    entry = table.findFile(cfile);
                    if (entry != null)
                    {
                        // backup
                        if (!File.Exists(table.pakName + ".bak"))
                            File.Copy(table.pakName, table.pakName + ".bak");
                        
                        // inject
                        Injector inj = new Injector(table.pakName);
                        string nfile = cfile.Replace('\\','/');
                        inj.inject(new string[] { nfile }, table.pakName+".new", pakpath);
                        File.Delete(table.pakName);
                        File.Move(table.pakName + ".new", table.pakName);
                        
                        MessageBox.Show("Inject ok !");
                        return;
                    }
                }
                MessageBox.Show("File not found in pak structure !");                
            }
        }
    }
}
